'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var edit = function edit() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var isEditing = _ref.isEditing;
  var onActivate = _ref.onActivate;
  var _onValue = _ref.onValue;
  var _ref$getEditedValue = _ref.getEditedValue;
  var getEditedValue = _ref$getEditedValue === undefined ? function (v) {
    return v;
  } : _ref$getEditedValue;

  if (!isEditing) {
    throw new Error('edit - Missing isEditing!');
  }
  if (!onActivate) {
    throw new Error('edit - Missing onActivate!');
  }
  if (!_onValue) {
    throw new Error('edit - Missing onValue!');
  }

  return function (editor) {
    if (!editor) {
      throw new Error('edit - Missing editor!');
    }

    return function (value, extraParameters) {
      var props = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];
      return isEditing(extraParameters) ? {
        children: _react2.default.createElement(editor, _extends({}, props, {
          value: getEditedValue(value),
          onValue: function onValue(v) {
            return _onValue(_extends({ value: v }, extraParameters));
          }
        }))
      } : _extends({}, props, {
        onClick: function onClick() {
          return onActivate(extraParameters);
        }
      });
    };
  };
};

exports.default = edit;